//
// Binary tree predictive coding version 5.1
//
// John Robinson 1994, 1995, 1997, 2002, 2003
//

#include "compact.h"
// #include "math.h"

inline int btpc_get_ridgethresh(int spacing) {
	// return (int)(10.0*log((double)spacing));
	// math-library-free approx to above
	int ret = 2*spacing + 5;
	if (ret > 16)
		ret = 16 + (ret-16)/2;
	if (ret > 32)
		ret = 32 + (ret-32)/8;
	if (ret < 8) // Spacing = 1
		ret = 1;
	return ret;
	}
int btpc_get_numlevels();

void rgb_ycc(unsigned char ***components,int ymax,int xmax, int smooth);

int makescratch(const int& xmax, const int& ymax);

int deletescratch(const int& ymax);

void btpc_enc_plane(unsigned char **in, const int& xmax, const int& ymax,
const int& fromlevel, const int& tolevel, const int *spacing, 
rlcomp *codeout, const int& minval, const int& maxval, const int& comp,
const int& truecols, const int& truerows);

int bincode(unsigned char ***pyr, const int& inrows, const int& incols, 
rlcomp *codeout, int fromlevel, const int *spacing, 
const int pnmtype, const int& truerows, const int& truecols);

void calc_colour_transform(unsigned char ***components, int *transform, 
int num_rows, int num_cols);

void rgb_pca(unsigned char ***components, int *transform, 
int num_rows, int num_cols);

int calcq(int dynamicrange, int quality, int *qvals, int numbands);

void gettrueminmax(unsigned char ***components, const int pnmtype,
int *minval, int *maxval, const int& rows, const int& cols);

int btpc_encode(unsigned char ***incomponents, FILE *cfp,
int truerows, int truecols, int padrows, int padcols, int pnmtype,
int quality, const char *comment);

void pad(unsigned char ***incomponents, unsigned char ***pbuf, 
int& rows, int& cols, int pnmtype);

const unsigned char **initclip(const int& bottomval, const int& topval, 
	int pnmtype);

void ycc_rgb(unsigned char ***components, const int& rows, const int& cols,
const unsigned char *clip, const char& expand);

void btpc_dec_plane(unsigned char ***out,const int& XMAX, const int& YMAX,
const int& fromlevel, const int *spacing,
rlcomp *codein, const int *minval, const int *maxval,
const int pnmtype, const int& truecols, const int& truerows);

void pca_rgb(unsigned char ***components, int *transform, 
int num_rows, int num_cols, const unsigned char **clip);

int btpc_read_header(FILE *cfp, int& pnmtype, int& rows, int& cols, 
int *minval, int *maxval, int *tminval, int *tmaxval, int& numlevels, 
char& coltype, int *spacing, int *transform, char **comment);

int btpc_decode(unsigned char ***components, FILE *cfp,
int& truerows, int& truecols, int& pnmtype, int& topmaxval, char **comment);

void btpc_finish(unsigned char ***components, int truerows, int truecols,
int pnmtype);

